import { Component, OnInit, ViewChild } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from '../../services/system.service';

@Component({
  selector: 'app-version-logs',
  templateUrl: './version-logs.component.html',
  styleUrls: ['./version-logs.component.less']
})
export class VersionLogsComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;

  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      expand: {
        type: 'boolean',
        ui: {
          hidden: true
        }
      },
      receiveName: {
        type: 'string',
        title: '端口',
        ui: { placeholder: '请输入' }
      },
      phone: {
        type: 'string',
        title: '端口方式',
        ui: { placeholder: '请输入' }
      },
      page: {
        type: 'string',
        title: '版本号',
        ui: {
          placeholder: '请输入'
        }
      },
      createTime: {
        title: '发布时间',
        type: 'string',
        ui: {
          widget: 'date',
          mode: 'range',
          format: 'yyyy-MM-dd',
          visibleIf: {
            expand: (value: boolean) => value
          }
        } as SFDateWidgetSchema
      }
    }
  };

  columns: STColumn[] = [
    { title: '端口', index: 'no' },
    { title: '端口方式', index: 'description' },
    { title: '版本号', index: 'description' },
    {
      title: '发布时间',
      index: 'updatedAt',
      type: 'date'
    },
    { title: '更新内容', index: 'description' }
  ];

  selectedRows: any[] = [];

  reqParams = { pageIndex: 1, pageSize: 10 };
  _$expand = false;

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  roleAction(item?: any) {}

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/expand', this._$expand);
  }
}
